library EXTDLL5;
uses
  windows,sysutils,classes;


TYPE
TCORRELATION = function(line1 : pointer;line2 : pointer; pixelocunt : dword):dword;stdcall;
lumtotstruc     = array [0..287] of dword;
yuy2bufferstruc = array [0..287,1..768] of word;
seqbufferstruc  = array [0..287] of dword;
extparamstruc   = record
                  yuy2buffer : ^yuy2bufferstruc;
                  seqbuffer  : ^seqbufferstruc;
                  overlay    : pointer;
                  flags      : dword;
                  corraddr   : pointer;
                  lumtots    : ^lumtotstruc;
                  saveflag   : dword;
                  end;

var extparam : ^extparamstruc;
correlation : tcorrelation;
f : text;

hashbuffer      : array[0..31] of dword;

alldiffs        : array[0..287,0..287] of dword;


const
pixelstart = 1;
noofpixels = 768;

function EXTPROC(extparamaddr : pointer): dword; stdcall;
var     i,x,y,z,topblack : dword;

begin
extparam:=extparamaddr;
@correlation:=extparam.corraddr;

for i:=0 to 287 do
    for x:=0 to 287 do alldiffs[i,x]:=$7fffffff;

for i:=0 to 31 do hashbuffer[i]:=i;
topblack:=0;


{repeat begin
       z:=1;
       for x:=0 to 31 do if extparam.lumtots[hashbuffer[x]]=0 then
        begin
        extparam.seqbuffer[topblack]:=hashbuffer[x];
        hashbuffer[x]:=topblack+32;
        z:=0;
        inc(topblack);
        break;
        end;
       end until (topblack=5) or (z=1);
}

extparam.seqbuffer[topblack]:=hashbuffer[0];
hashbuffer[0]:=32+topblack;


for i:=topblack+1 to 254 do
begin
z:=$7fffffff;
y:=0;
for x:=0 to 31 do if alldiffs[extparam.seqbuffer[i-1],hashbuffer[x]]=z then
        begin
        alldiffs[extparam.seqbuffer[i-1],hashbuffer[x]]:=correlation(@extparam.yuy2buffer[extparam.seqbuffer[i-1],pixelstart],@extparam.yuy2buffer[hashbuffer[x],pixelstart],noofpixels);
        alldiffs[hashbuffer[x],extparam.seqbuffer[i-1]]:=alldiffs[extparam.seqbuffer[i-1],hashbuffer[x]];
        end;

for x:=0 to 31 do if alldiffs[extparam.seqbuffer[i-1],hashbuffer[x]]<z then
        begin
        z:=alldiffs[extparam.seqbuffer[i-1],hashbuffer[x]];
        y:=x;
        end;

extparam.seqbuffer[i]:=hashbuffer[y];
hashbuffer[y]:=i+32;
end;

for i:=255 to 286 do extparam.seqbuffer[i]:=hashbuffer[i-255];
extparam.seqbuffer[287]:=287;

for i:=0 to 286 do writeln(f,inttostr(extparam.seqbuffer[i]));

extproc:=0;
end;

exports
  EXTPROC;
procedure DLLHandler(Reason: Integer);
begin
if reason=DLL_PROCESS_DETACH then closefile(f);
end;

begin
DLLProc:=@dllhandler;
assignfile(f,'sort.lst');
if fileexists('sort.lst')=false then rewrite(f)
                                else append(f);
end.



