library EXTDLL9;
uses
  windows,sysutils,classes,tsp;


TYPE
TCORRELATION = function(line1 : pointer;line2 : pointer; pixelocunt : dword):dword;stdcall;
lumtotstruc     = array [1..288] of dword;
yuy2bufferstruc = array [1..288,1..768] of word;
seqbufferstruc  = array [1..288] of dword;
extparamstruc   = record
                  yuy2buffer : ^yuy2bufferstruc;
                  seqbuffer  : ^seqbufferstruc;
                  overlay    : pointer;
                  flags      : dword;
                  corraddr   : pointer;
                  lumtots    : ^lumtotstruc;
                  saveflag   : dword;
                  end;

var extparam : ^extparamstruc;
correlation : tcorrelation;

alldiffs        : ARRNN;
PATH,tp         : ARRN;
bestdiff        : integer;
nonblacks       : ARRN;
nonblackcount   : integer;
topblack        : integer;
fileno          : integer;
filepath        : string;
filename        : string;
sortlist        : tstringlist;
savefile        : file ;
fileheader      : array[0..1] of dword;

const
pixelstart = 1;
noofpixels = 768;
maxdiff    = $7fffffff;

function EXTPROC(extparamaddr : pointer): dword; stdcall;
var     i,x,z,y,n : longint;


begin
try
extparam:=extparamaddr;
@correlation:=extparam.corraddr;

x:=1;
nonblackcount:=287;
topblack:=0;
for i:=1 to 287 do if extparam.lumtots[i]>2000 then
        begin
        nonblacks[x]:=i;
        inc(x);
        end
        else
        begin
        dec(nonblackcount);
        if i<(33+topblack) then begin
                                inc(topblack);
                                extparam.seqbuffer[topblack]:=i-1;
                                end
                                else
                                begin
                                extparam.seqbuffer[nonblackcount+1]:=i-1;
                                end;
        end;


for i:=1 to nonblackcount-1 do
    for x:=i+1 to nonblackcount do
    begin
    alldiffs[i,x]:=correlation(@extparam.yuy2buffer[nonblacks[i],pixelstart],@extparam.yuy2buffer[nonblacks[x],pixelstart],noofpixels);
    //if x-i>96 then alldiffs[i,x]:=trunc(alldiffs[i,x]*(1+(x-i-96)/246));
    alldiffs[x,i]:=alldiffs[i,x];
    end;
for i:=1 to 288 do
        begin
        path[i]:=i;
        tp[i]:=i;
        extparam.seqbuffer[i]:=i-1;
        alldiffs[i,i]:=maxdiff;
        end;
//babtsp(nonblackcount,maxdiff,alldiffs,path,bestdiff);
fitsp(nonblackcount,1,maxdiff,alldiffs,path,bestdiff);
//anneal(tp,tp,alldiffs,path,nonblackcount);
twoopt(nonblackcount,alldiffs,path,bestdiff);
//threeopt(nonblackcount,alldiffs,path,bestdiff);


// Correct tsp-path orientation
z:=0;
for i:=1 to nonblackcount-50 do if path[i]<path[i+40] then inc(z) else dec(z);
for i:=1 to nonblackcount do tp[i]:=path[i];
if z<0 then for i:=1 to nonblackcount do path[i]:=tp[nonblackcount-i+1];

z:=0;
y:=500;
for x:=0 to nonblackcount-1 do
        begin
        n:=0;
        for i:=1 to nonblackcount do
                if path[((i+x) mod nonblackcount)+1]>31+i then inc(n);
        if n<y then begin
                    y:=n;
                    z:=x;
                    end;
        end;

for i:=1 to nonblackcount do tp[i]:=path[i];
for i:=1 to nonblackcount do path[i]:=tp[((i+z) mod nonblackcount)+1];

// Copy path to seqbuffer with correct line numbers
//if topblack<>0 then for i:=1 to topblack do extparam.seqbuffer[i]:=287;

for i:=1 to nonblackcount do extparam.seqbuffer[i+topblack]:=nonblacks[PATH[i]]-1;
//for i:=nonblackcount+1+topblack to 288 do extparam.seqbuffer[i]:=287;
extparam.seqbuffer[288]:=287;
extproc:=0;

//outputdebugstring(pchar(inttostr(hashcount)+#13#10));
if extparam.saveflag<>0 then
        begin
        fileheader[0]:=0;
        fileheader[1]:=768;
        filepath:=getcurrentdir+'\pic\';
        fileno:=0;
        repeat inc(fileno) until fileexists(filepath+'testpic.'+inttostr(fileno))=false;
        filename:=filepath+'testpic.'+inttostr(fileno);
        assignfile(savefile,filename);
        rewrite(savefile,1);
        blockwrite(savefile,fileheader,8);
        blockwrite(savefile,extparam.yuy2buffer[1,1],768*2*287);
        closefile(savefile);
        sortlist:=tstringlist.create;
        sortlist.clear;
        for i:=1 to 287 do sortlist.add(inttostr(extparam.seqbuffer[i]));
        filename:=filepath+'sort.'+inttostr(fileno);
        sortlist.savetofile(filename);
        sortlist.Free;
        extparam.saveflag:=0;
        end;
finally
end;

end;

exports
  EXTPROC;

begin
end.


